package com.logicbig.example;


import org.fluttercode.datafactory.impl.DataFactory;

import java.util.ArrayList;
import java.util.List;

public enum DataService {
    Instance;
    private String roles[] =
            {"Project Manager", "Tech Lead", "Developer", "Scrum Master", "Business Analyst"};

    private DataFactory dataFactory = new DataFactory();
    private List<ProjectModule> modules = new ArrayList<>();

    DataService() {
        //creating dummy projects
        addProject("Trading", "Real Time Trading", "Order System");
        addProject("Future/Option", "Option Analyzer", "Market Scanning System");
        addProject("Fixed Income", "Bond Tool", "Price/Yield Calculator",
                "Strategy Evaluator");
    }

    private void addProject(String module, String... projects) {
        ProjectModule pm = new ProjectModule();
        pm.setModuleName(module);
        for (String project : projects) {
            List<Employee> list = new ArrayList<>();
            for (String role : roles) {
                Employee e = new Employee();
                e.setProject(project);
                e.setRole(role);
                e.setName(dataFactory.getName());
                e.setPhone(String.format("%s-%s-%s", dataFactory.getNumberText(3),
                        dataFactory.getNumberText(3),
                        dataFactory.getNumberText(4)));
                list.add(e);

            }
            pm.addProject(project, list);
        }
        modules.add(pm);
    }

    public List<ProjectModule> getProjectModules() {
        return modules;
    }
}